Index: uspace/lib/nettl/src/amap.c
===================================================================
--- uspace/lib/nettl/src/amap.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/nettl/src/amap.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -36,4 +36,16 @@
  * Manages allocations of endpoints / endpoint pairs (corresponding to
  * UDP associations, TCP listeners and TCP connections)
+ *
+ * An association map contains different types of entries, based on which
+ * set of attributes (key) they specify. In order from most specific to the
+ * least specific one:
+ *
+ *  - repla (remote endpoint, local address)
+ *  - laddr (local address)
+ *  - llink (local link)
+ *  - unspec (unspecified)
+ *
+ * In the unspecified case only the local port is known and the entry matches
+ * all remote and local addresses.
  */
 
@@ -47,4 +59,9 @@
 #include <stdlib.h>
 
+/** Create association map.
+ *
+ * @param rmap Place to store pointer to new association map
+ * @return EOk on success, ENOMEM if out of memory
+ */
 int amap_create(amap_t **rmap)
 {
@@ -73,4 +90,8 @@
 }
 
+/** Destroy association map.
+ *
+ * @param map Association map
+ */
 void amap_destroy(amap_t *map)
 {
@@ -79,5 +100,15 @@
 }
 
-/** Find exact repla */
+/** Find exact repla.
+ *
+ * Find repla (remote endpoint, local address) entry by exact match.
+ *
+ * @param map Association map
+ * @param rep Remote endpoint
+ * @param la  Local address
+ * @param rrepla Place to store pointer to repla
+ *
+ * @return EOK on success, ENOENT if not found
+ */
 static int amap_repla_find(amap_t *map, inet_ep_t *rep, inet_addr_t *la,
     amap_repla_t **rrepla)
@@ -113,4 +144,15 @@
 }
 
+/** Insert repla.
+ *
+ * Insert new repla (remote endpoint, local address) entry to association map.
+ *
+ * @param amap   Association map
+ * @param rep    Remote endpoint
+ * @param la     Local address
+ * @param rrepla Place to store pointer to new repla
+ *
+ * @return EOK on success, ENOMEM if out of memory
+ */
 static int amap_repla_insert(amap_t *map, inet_ep_t *rep, inet_addr_t *la,
     amap_repla_t **rrepla)
@@ -139,4 +181,11 @@
 }
 
+/** Remove repla from association map.
+ *
+ * Remove repla (remote endpoint, local address) from association map.
+ *
+ * @param map   Association map
+ * @param repla Repla
+ */
 static void amap_repla_remove(amap_t *map, amap_repla_t *repla)
 {
@@ -146,5 +195,14 @@
 }
 
-/** Find exact laddr */
+/** Find exact laddr.
+ *
+ * Find laddr (local address) entry by exact match.
+ *
+ * @param map    Association map
+ * @param addr   Address
+ * @param rladdr Place to store pointer to laddr entry
+ *
+ * @return EOK on success, ENOENT if not found.
+ */
 static int amap_laddr_find(amap_t *map, inet_addr_t *addr,
     amap_laddr_t **rladdr)
@@ -161,4 +219,13 @@
 }
 
+/** Insert laddr.
+ *
+ * Insert new laddr (local address) entry to association map.
+ *
+ * @param addr   Local address
+ * @param rladdr Place to store pointer to new laddr
+ *
+ * @return EOK on success, ENOMEM if out of memory
+ */
 static int amap_laddr_insert(amap_t *map, inet_addr_t *addr,
     amap_laddr_t **rladdr)
@@ -186,4 +253,11 @@
 }
 
+/** Remove laddr from association map.
+ *
+ * Remove laddr (local address) entry from association map.
+ *
+ * @param map   Association map
+ * @param laddr Laddr entry
+ */
 static void amap_laddr_remove(amap_t *map, amap_laddr_t *laddr)
 {
@@ -193,5 +267,14 @@
 }
 
-/** Find exact llink */
+/** Find exact llink.
+ *
+ * Find llink (local link) entry by exact match.
+ *
+ * @param map     Association map
+ * @param link_id Local link ID
+ * @param rllink  Place to store pointer to llink entry
+ *
+ * @return EOK on success, ENOENT if not found.
+ */
 static int amap_llink_find(amap_t *map, sysarg_t link_id,
     amap_llink_t **rllink)
@@ -208,4 +291,13 @@
 }
 
+/** Insert llink.
+ *
+ * Insert new llink (local link) entry to association map.
+ *
+ * @param link_id Local link
+ * @param rllink  Place to store pointer to new llink
+ *
+ * @return EOK on success, ENOMEM if out of memory
+ */
 static int amap_llink_insert(amap_t *map, sysarg_t link_id,
     amap_llink_t **rllink)
@@ -233,4 +325,11 @@
 }
 
+/** Remove llink from association map.
+ *
+ * Remove llink (local link) entry from association map.
+ *
+ * @param map   Association map
+ * @param llink Llink entry
+ */
 static void amap_llink_remove(amap_t *map, amap_llink_t *llink)
 {
@@ -240,4 +339,17 @@
 }
 
+/** Insert endpoint pair into map with repla as key.
+ *
+ * If local port number is not specified, it is allocated.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair, possibly with local port inet_port_any
+ * @param arg arg User value
+ * @param flags Flags
+ * @param aepp Place to store actual endpoint pair, possibly with allocated port
+ *
+ * @return EOK on success, EEXIST if conflicting epp exists,
+ *         ENOMEM if out of memory
+ */
 static int amap_insert_repla(amap_t *map, inet_ep2_t *epp, void *arg,
     amap_flags_t flags, inet_ep2_t *aepp)
@@ -272,4 +384,17 @@
 }
 
+/** Insert endpoint pair into map with laddr as key.
+ *
+ * If local port number is not specified, it is allocated.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair, possibly with local port inet_port_any
+ * @param arg arg User value
+ * @param flags Flags
+ * @param aepp Place to store actual endpoint pair, possibly with allocated port
+ *
+ * @return EOK on success, EEXIST if conflicting epp exists,
+ *         ENOMEM if out of memory
+ */
 static int amap_insert_laddr(amap_t *map, inet_ep2_t *epp, void *arg,
     amap_flags_t flags, inet_ep2_t *aepp)
@@ -303,4 +428,17 @@
 }
 
+/** Insert endpoint pair into map with llink as key.
+ *
+ * If local port number is not specified, it is allocated.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair, possibly with local port inet_port_any
+ * @param arg arg User value
+ * @param flags Flags
+ * @param aepp Place to store actual endpoint pair, possibly with allocated port
+ *
+ * @return EOK on success, EEXIST if conflicting epp exists,
+ *         ENOMEM if out of memory
+ */
 static int amap_insert_llink(amap_t *map, inet_ep2_t *epp, void *arg,
     amap_flags_t flags, inet_ep2_t *aepp)
@@ -334,27 +472,7 @@
 }
 
-static int amap_insert_unspec(amap_t *map, inet_ep2_t *epp, void *arg,
-    amap_flags_t flags, inet_ep2_t *aepp)
-{
-	inet_ep2_t mepp;
-	int rc;
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert_unspec()");
-	mepp = *epp;
-
-	rc = portrng_alloc(map->unspec, epp->local.port, arg, flags,
-	    &mepp.local.port);
-	if (rc != EOK) {
-		return rc;
-	}
-
-	*aepp = mepp;
-	return EOK;
-}
-
-/** Insert endpoint pair into map.
- *
- * If local endpoint is not fully specified, it is filled in (determine
- * source address, allocate port number). Checks for conflicting endpoint pair.
+/** Insert endpoint pair into map with unspec as key.
+ *
+ * If local port number is not specified, it is allocated.
  *
  * @param map Association map
@@ -364,5 +482,38 @@
  * @param aepp Place to store actual endpoint pair, possibly with allocated port
  *
- * @return EOK on success, EEXISTS if conflicting epp exists,
+ * @return EOK on success, EEXIST if conflicting epp exists,
+ *         ENOMEM if out of memory
+ */
+static int amap_insert_unspec(amap_t *map, inet_ep2_t *epp, void *arg,
+    amap_flags_t flags, inet_ep2_t *aepp)
+{
+	inet_ep2_t mepp;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_insert_unspec()");
+	mepp = *epp;
+
+	rc = portrng_alloc(map->unspec, epp->local.port, arg, flags,
+	    &mepp.local.port);
+	if (rc != EOK) {
+		return rc;
+	}
+
+	*aepp = mepp;
+	return EOK;
+}
+
+/** Insert endpoint pair into map.
+ *
+ * If local endpoint is not fully specified, it is filled in (determine
+ * source address, allocate port number). Checks for conflicting endpoint pair.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair, possibly with local port inet_port_any
+ * @param arg arg User value
+ * @param flags Flags
+ * @param aepp Place to store actual endpoint pair, possibly with allocated port
+ *
+ * @return EOK on success, EEXIST if conflicting epp exists,
  *         ENOMEM if out of memory
  */
@@ -417,4 +568,12 @@
 }
 
+/** Remove endpoint pair using repla as key from map.
+ *
+ * The endpoint pair must be present in the map, otherwise behavior
+ * is unspecified.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair
+ */
 static void amap_remove_repla(amap_t *map, inet_ep2_t *epp)
 {
@@ -434,4 +593,12 @@
 }
 
+/** Remove endpoint pair using laddr as key from map.
+ *
+ * The endpoint pair must be present in the map, otherwise behavior
+ * is unspecified.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair
+ */
 static void amap_remove_laddr(amap_t *map, inet_ep2_t *epp)
 {
@@ -451,4 +618,12 @@
 }
 
+/** Remove endpoint pair using llink as key from map.
+ *
+ * The endpoint pair must be present in the map, otherwise behavior
+ * is unspecified.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair
+ */
 static void amap_remove_llink(amap_t *map, inet_ep2_t *epp)
 {
@@ -468,4 +643,12 @@
 }
 
+/** Remove endpoint pair using unspec as key from map.
+ *
+ * The endpoint pair must be present in the map, otherwise behavior
+ * is unspecified.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair
+ */
 static void amap_remove_unspec(amap_t *map, inet_ep2_t *epp)
 {
@@ -473,4 +656,12 @@
 }
 
+/** Remove endpoint pair from map.
+ *
+ * The endpoint pair must be present in the map, otherwise behavior
+ * is unspecified.
+ *
+ * @param map Association map
+ * @param epp Endpoint pair
+ */
 void amap_remove(amap_t *map, inet_ep2_t *epp)
 {
Index: uspace/lib/nettl/src/portrng.c
===================================================================
--- uspace/lib/nettl/src/portrng.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/nettl/src/portrng.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -46,4 +46,9 @@
 #include <io/log.h>
 
+/** Create port range.
+ *
+ * @param rpr Place to store pointer to new port range
+ * @return EOK on success, ENOMEM if out of memory
+ */
 int portrng_create(portrng_t **rpr)
 {
@@ -62,4 +67,8 @@
 }
 
+/** Destroy port range.
+ *
+ * @param pr Port range
+ */
 void portrng_destroy(portrng_t *pr)
 {
@@ -69,4 +78,19 @@
 }
 
+/** Allocate port number from port range.
+ *
+ * @param pr    Port range
+ * @param pnum  Port number to allocate specific port, or zero to allocate
+ *              any valid port from range
+ * @param arg   User argument to set for port
+ * @param flags Flags, @c pf_allow_system to allow ports from system range
+ *              to be specified by @a pnum.
+ * @param apnum Place to store allocated port number
+ *
+ * @return EOK on success, ENOENT if no free port number found, EEXIST
+ *         if @a pnum is specified but it is already allocated,
+ *         EINVAL if @a pnum is specified from the system range, but
+ *         @c pf_allow_system was not set.
+ */
 int portrng_alloc(portrng_t *pr, uint16_t pnum, void *arg,
     portrng_flags_t flags, uint16_t *apnum)
@@ -113,5 +137,5 @@
 			if (port->pn == pnum) {
 				log_msg(LOG_DEFAULT, LVL_DEBUG2, "port already used");
-				return EEXISTS;
+				return EEXIST;
 			}
 		}
@@ -131,4 +155,12 @@
 }
 
+/** Find allocated port number and return its argument.
+ *
+ * @param pr   Port range
+ * @param pnum Port number
+ * @param rarg Place to store user argument
+ *
+ * @return EOK on success, ENOENT if specified port number is not allocated
+ */
 int portrng_find_port(portrng_t *pr, uint16_t pnum, void **rarg)
 {
@@ -143,4 +175,9 @@
 }
 
+/** Free port in port range.
+ *
+ * @param pr   Port range
+ * @param pnum Port number
+ */
 void portrng_free_port(portrng_t *pr, uint16_t pnum)
 {
@@ -158,4 +195,9 @@
 }
 
+/** Determine if port range is empty.
+ *
+ * @param pr Port range
+ * @return @c true if no ports are allocated from @a pr, @c false otherwise
+ */
 bool portrng_empty(portrng_t *pr)
 {
Index: uspace/lib/nic/src/nic_driver.c
===================================================================
--- uspace/lib/nic/src/nic_driver.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/nic/src/nic_driver.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -249,5 +249,5 @@
 	
 	/* Connect to the parent's driver. */
-	parent_sess = ddf_dev_parent_sess_create(dev, EXCHANGE_SERIALIZE);
+	parent_sess = ddf_dev_parent_sess_create(dev);
 	if (parent_sess == NULL)
 		return EPARTY;
Index: uspace/lib/pcut/src/os/helenos.c
===================================================================
--- uspace/lib/pcut/src/os/helenos.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/pcut/src/os/helenos.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -220,5 +220,5 @@
 	fibril_mutex_unlock(&forced_termination_mutex);
 
-	read_all(tempfile, extra_output_buffer, OUTPUT_BUFFER_SIZE);
+	read(tempfile, extra_output_buffer, OUTPUT_BUFFER_SIZE);
 
 leave_close_tempfile:
Index: uspace/lib/posix/include/posix/inttypes.h
===================================================================
--- uspace/lib/posix/include/posix/inttypes.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/include/posix/inttypes.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -43,7 +43,7 @@
 #include "libc/inttypes.h"
 
-extern __POSIX_DEF__(intmax_t) __POSIX_DEF__(strtoimax)(const char *restrict nptr,
+extern intmax_t __POSIX_DEF__(strtoimax)(const char *restrict nptr,
     char **restrict endptr, int base);
-extern __POSIX_DEF__(uintmax_t) __POSIX_DEF__(strtoumax)(const char *restrict nptr,
+extern uintmax_t __POSIX_DEF__(strtoumax)(const char *restrict nptr,
     char **restrict endptr, int base);
 
Index: uspace/lib/posix/include/posix/stddef.h
===================================================================
--- uspace/lib/posix/include/posix/stddef.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/include/posix/stddef.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -48,7 +48,4 @@
 #define offsetof(type,member) ((size_t) &(((type *) 0)->member))
 
-typedef ssize_t __POSIX_DEF__(ptrdiff_t);
-
-
 #endif /* POSIX_STDDEF_H_ */
 
Index: uspace/lib/posix/include/posix/stdint.h
===================================================================
--- uspace/lib/posix/include/posix/stdint.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/include/posix/stdint.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -104,12 +104,10 @@
 #include "libc/sys/types.h"
 
-typedef int64_t __POSIX_DEF__(intmax_t);
-typedef uint64_t __POSIX_DEF__(uintmax_t);
-
-
 /*
  * Fast* and least* integer types.
  *
- * The definitions below are definitely safe if not the best.
+ * The definitions below are correct as long as uint8/16/32/64_t are defined.
+ * Considering the entire rest of the system would break down if they were not,
+ * these definitions are just fine.
  */
 typedef uint8_t uint_least8_t;
Index: uspace/lib/posix/source/fcntl.c
===================================================================
--- uspace/lib/posix/source/fcntl.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/fcntl.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -112,11 +112,5 @@
 	}
 
-	int rc = open(pathname, flags, mode);
-	if (rc < 0) {
-		errno = -rc;
-		rc = -1;
-	}
-
-	return rc;
+	return negerrno(open, pathname, flags, mode);
 }
 
Index: uspace/lib/posix/source/internal/common.h
===================================================================
--- uspace/lib/posix/source/internal/common.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/internal/common.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -48,10 +48,9 @@
 	} while (0)
 
-/* A little helper macro to avoid typing this over and over. */
-#define errnify(func, ...) ({ \
+/* Convert negative errno to positive errno */
+#define negerrno(func, ...) ({ \
 	int rc = func(__VA_ARGS__); \
 	if (rc < 0) { \
-		errno = -rc; \
-		rc = -1; \
+		errno = -errno; \
 	} \
 	rc; \
Index: uspace/lib/posix/source/stdio.c
===================================================================
--- uspace/lib/posix/source/stdio.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/stdio.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -55,10 +55,4 @@
 #include "libc/sys/stat.h"
 
-
-/* not the best of solutions, but freopen and ungetc will eventually
- * need to be implemented in libc anyway
- */
-#include "../../c/generic/private/stdio.h"
-
 /** Clears the stream's error and end-of-file indicators.
  *
@@ -67,6 +61,5 @@
 void posix_clearerr(FILE *stream)
 {
-	stream->error = 0;
-	stream->eof = 0;
+	clearerr(stream);
 }
 
@@ -101,10 +94,5 @@
 int posix_fputs(const char *restrict s, FILE *restrict stream)
 {
-	int rc = fputs(s, stream);
-	if (rc == 0) {
-		return EOF;
-	} else {
-		return 0;
-	}
+	return fputs(s, stream);
 }
 
@@ -118,33 +106,5 @@
 int posix_ungetc(int c, FILE *stream)
 {
-	uint8_t b = (uint8_t) c;
-
-	bool can_unget =
-	    /* Provided character is legal. */
-	    c != EOF &&
-	    /* Stream is consistent. */
-	    !stream->error &&
-	    /* Stream is buffered. */
-	    stream->btype != _IONBF &&
-	    /* Last operation on the stream was a read operation. */
-	    stream->buf_state == _bs_read &&
-	    /* Stream buffer is already allocated (i.e. there was already carried
-	     * out either write or read operation on the stream). This is probably
-	     * redundant check but let's be safe. */
-	    stream->buf != NULL &&
-	    /* There is still space in the stream to retreat. POSIX demands the
-	     * possibility to unget at least 1 character. It should be always
-	     * possible, assuming the last operation on the stream read at least 1
-	     * character, because the buffer is refilled in the lazily manner. */
-	    stream->buf_tail > stream->buf;
-
-	if (can_unget) {
-		--stream->buf_tail;
-		stream->buf_tail[0] = b;
-		stream->eof = false;
-		return (int) b;
-	} else {
-		return EOF;
-	}
+	return ungetc(c, stream);
 }
 
@@ -254,43 +214,5 @@
     const char *restrict mode, FILE *restrict stream)
 {
-	assert(mode != NULL);
-	assert(stream != NULL);
-	
-	if (filename == NULL) {
-		/* POSIX allows this to be imlementation-defined. HelenOS currently
-		 * does not support changing the mode. */
-		// FIXME: handle mode change once it is supported
-		return stream;
-	}
-	
-	/* Open a new stream. */
-	FILE* new = fopen(filename, mode);
-	if (new == NULL) {
-		fclose(stream);
-		/* errno was set by fopen() */
-		return NULL;
-	}
-	
-	/* Close the original stream without freeing it (ignoring errors). */
-	if (stream->buf != NULL) {
-		fflush(stream);
-	}
-	if (stream->sess != NULL) {
-		async_hangup(stream->sess);
-	}
-	if (stream->fd >= 0) {
-		close(stream->fd);
-	}
-	list_remove(&stream->link);
-	
-	/* Move the new stream to the original location. */
-	memcpy(stream, new, sizeof (FILE));
-	free(new);
-	
-	/* Update references in the file list. */
-	stream->link.next->prev = &stream->link;
-	stream->link.prev->next = &stream->link;
-	
-	return stream;
+	return freopen(filename, mode, stream);
 }
 
@@ -393,11 +315,5 @@
 int posix_fflush(FILE *stream)
 {
-	int rc = fflush(stream);
-	if (rc < 0) {
-		errno = -rc;
-		return EOF;
-	} else {
-		return 0;
-	}
+	return negerrno(fflush, stream);
 }
 
@@ -429,4 +345,6 @@
 {
 	ssize_t wr = write(*(int *) fd, str, size);
+	if (wr < 0)
+		return errno;
 	return str_nlength(str, wr);
 }
@@ -657,23 +575,5 @@
 int posix_remove(const char *path)
 {
-	struct stat st;
-	int rc = stat(path, &st);
-	
-	if (rc != EOK) {
-		errno = -rc;
-		return -1;
-	}
-	
-	if (st.is_directory) {
-		rc = rmdir(path);
-	} else {
-		rc = unlink(path);
-	}
-	
-	if (rc != EOK) {
-		errno = -rc;
-		return -1;
-	}
-	return 0;
+	return negerrno(remove, path);
 }
 
@@ -687,5 +587,5 @@
 int posix_rename(const char *old, const char *new)
 {
-	return errnify(rename, old, new);
+	return negerrno(rename, old, new);
 }
 
Index: uspace/lib/posix/source/stdio/scanf.c
===================================================================
--- uspace/lib/posix/source/stdio/scanf.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/stdio/scanf.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -698,6 +698,6 @@
 							break;
 						case LMOD_j: ;
-							posix_uintmax_t *pj = va_arg(arg, posix_uintmax_t *);
-							*pj = (posix_uintmax_t) ures;
+							uintmax_t *pj = va_arg(arg, uintmax_t *);
+							*pj = (uintmax_t) ures;
 							break;
 						case LMOD_z: ;
@@ -740,6 +740,6 @@
 							break;
 						case LMOD_j: ;
-							posix_intmax_t *pj = va_arg(arg, posix_intmax_t *);
-							*pj = (posix_intmax_t) sres;
+							intmax_t *pj = va_arg(arg, intmax_t *);
+							*pj = (intmax_t) sres;
 							break;
 						case LMOD_z: ;
@@ -748,6 +748,6 @@
 							break;
 						case LMOD_t: ;
-							posix_ptrdiff_t *pt = va_arg(arg, posix_ptrdiff_t *);
-							*pt = (posix_ptrdiff_t) sres;
+							ptrdiff_t *pt = va_arg(arg, ptrdiff_t *);
+							*pt = (ptrdiff_t) sres;
 							break;
 						default:
Index: uspace/lib/posix/source/stdlib.c
===================================================================
--- uspace/lib/posix/source/stdlib.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/stdlib.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -278,5 +278,5 @@
 	 * to be updated when that support is implemented.
 	 */
-	char* absolute = absolutize(name, NULL);
+	char* absolute = vfs_absolutize(name, NULL);
 	
 	if (absolute == NULL) {
Index: uspace/lib/posix/source/stdlib/strtol.c
===================================================================
--- uspace/lib/posix/source/stdlib/strtol.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/stdlib/strtol.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -43,7 +43,4 @@
 #include "posix/inttypes.h"
 #include "posix/limits.h"
-
-#define intmax_t posix_intmax_t
-#define uintmax_t posix_uintmax_t
 
 /**
Index: uspace/lib/posix/source/sys/stat.c
===================================================================
--- uspace/lib/posix/source/sys/stat.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/sys/stat.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -80,10 +80,7 @@
 {
 	struct stat hst;
-	int rc = fstat(fd, &hst);
-	if (rc < 0) {
-		/* fstat() returns negative error code instead of using errno. */
-		errno = -rc;
-		return -1;
-	}
+	int rc = negerrno(fstat, fd, &hst);
+	if (rc < 0)
+		return rc;
 	stat_to_posix(st, &hst);
 	return 0;
@@ -113,10 +110,7 @@
 {
 	struct stat hst;
-	int rc = stat(path, &hst);
-	if (rc < 0) {
-		/* stat() returns negative error code instead of using errno. */
-		errno = -rc;
-		return -1;
-	}
+	int rc = negerrno(stat, path, &hst);
+	if (rc < 0)
+		return rc;
 	stat_to_posix(st, &hst);
 	return 0;
Index: uspace/lib/posix/source/unistd.c
===================================================================
--- uspace/lib/posix/source/unistd.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/posix/source/unistd.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -105,31 +105,12 @@
 char *posix_getcwd(char *buf, size_t size)
 {
-	/* Native getcwd() does not set any errno despite the fact that general
-	 * usage pattern of this function depends on it (caller is repeatedly
-	 * guessing the required size of the buffer by checking for ERANGE on
-	 * failure). */
-	if (size == 0) {
-		errno = EINVAL;
+	char *p = getcwd(buf, size);
+
+	if (p == NULL) {
+		errno = -errno;
 		return NULL;
 	}
-	
-	/* Save the original value to comply with the "no modification on
-	 * success" semantics.
-	 */
-	int orig_errno = errno;
-	errno = EOK;
-	
-	char *ret = getcwd(buf, size);
-	if (ret == NULL) {
-		/* Check errno to avoid shadowing other possible errors. */
-		if (errno == EOK) {
-			errno = ERANGE;
-		}
-	} else {
-		/* Success, restore previous errno value. */
-		errno = orig_errno;
-	}
-	
-	return ret;
+
+	return p;
 }
 
@@ -141,5 +122,5 @@
 int posix_chdir(const char *path)
 {
-	return errnify(chdir, path);
+	return negerrno(chdir, path);
 }
 
@@ -194,5 +175,5 @@
 int posix_close(int fildes)
 {
-	return errnify(close, fildes);
+	return negerrno(close, fildes);
 }
 
@@ -207,5 +188,5 @@
 ssize_t posix_read(int fildes, void *buf, size_t nbyte)
 {
-	return errnify(read, fildes, buf, nbyte);
+	return negerrno(read, fildes, buf, nbyte);
 }
 
@@ -220,5 +201,5 @@
 ssize_t posix_write(int fildes, const void *buf, size_t nbyte)
 {
-	return errnify(write, fildes, buf, nbyte);
+	return negerrno(write, fildes, buf, nbyte);
 }
 
@@ -234,5 +215,5 @@
 posix_off_t posix_lseek(int fildes, posix_off_t offset, int whence)
 {
-	return errnify(lseek, fildes, offset, whence);
+	return negerrno(lseek, fildes, offset, whence);
 }
 
@@ -245,5 +226,5 @@
 int posix_fsync(int fildes)
 {
-	return errnify(fsync, fildes);
+	return negerrno(fsync, fildes);
 }
 
@@ -257,5 +238,5 @@
 int posix_ftruncate(int fildes, posix_off_t length)
 {
-	return errnify(ftruncate, fildes, (aoff64_t) length);
+	return negerrno(ftruncate, fildes, (aoff64_t) length);
 }
 
@@ -268,5 +249,5 @@
 int posix_rmdir(const char *path)
 {
-	return errnify(rmdir, path);
+	return negerrno(rmdir, path);
 }
 
@@ -279,5 +260,5 @@
 int posix_unlink(const char *path)
 {
-	return errnify(unlink, path);
+	return negerrno(unlink, path);
 }
 
@@ -303,5 +284,5 @@
 int posix_dup2(int fildes, int fildes2)
 {
-	return errnify(dup2, fildes, fildes2);
+	return negerrno(dup2, fildes, fildes2);
 }
 
@@ -321,7 +302,7 @@
 		 * Check file existence by attempting to open it.
 		 */
-		int fd = open(path, O_RDONLY);
+		int fd = negerrno(open, path, O_RDONLY);
 		if (fd < 0) {
-			errno = -fd;
+			/* errno was set by open() */
 			return -1;
 		}
Index: uspace/lib/usb/src/dev.c
===================================================================
--- uspace/lib/usb/src/dev.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/usb/src/dev.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -50,6 +50,5 @@
 {
 	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_ATOMIC, device_handle,
-	        IPC_FLAG_BLOCKING);
+	    devman_parent_device_connect(device_handle, IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
Index: uspace/lib/usb/src/hc.c
===================================================================
--- uspace/lib/usb/src/hc.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/usb/src/hc.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -51,6 +51,5 @@
 		assert(connection->hc_sess == NULL);
 		/* Parallel exchange for us */
-		connection->hc_sess = devman_device_connect(EXCHANGE_PARALLEL,
-		        connection->hc_handle, 0);
+		connection->hc_sess = devman_device_connect(connection->hc_handle, 0);
 		if (!connection->hc_sess) {
 			fibril_mutex_unlock(&connection->guard);
Index: uspace/lib/usbdev/src/pipesinit.c
===================================================================
--- uspace/lib/usbdev/src/pipesinit.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/usbdev/src/pipesinit.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -190,5 +190,5 @@
 
 	if (ep_mapping->present) {
-		return EEXISTS;
+		return EEXIST;
 	}
 
Index: uspace/lib/usbhost/src/usb_device_manager.c
===================================================================
--- uspace/lib/usbhost/src/usb_device_manager.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/usbhost/src/usb_device_manager.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -150,5 +150,5 @@
 	if (instance->devices[address].handle != 0) {
 		fibril_mutex_unlock(&instance->guard);
-		return EEXISTS;
+		return EEXIST;
 	}
 	instance->devices[address].handle = handle;
Index: uspace/lib/usbhost/src/usb_endpoint_manager.c
===================================================================
--- uspace/lib/usbhost/src/usb_endpoint_manager.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/usbhost/src/usb_endpoint_manager.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -253,5 +253,5 @@
 	if (endpoint != NULL) {
 		fibril_mutex_unlock(&instance->guard);
-		return EEXISTS;
+		return EEXIST;
 	}
 	list_append(&ep->link, get_list(instance, ep->address));
@@ -339,5 +339,5 @@
 	if (ep != NULL) {
 		fibril_mutex_unlock(&instance->guard);
-		return EEXISTS;
+		return EEXIST;
 	}
 
Index: uspace/lib/usbvirt/src/device.c
===================================================================
--- uspace/lib/usbvirt/src/device.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/lib/usbvirt/src/device.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -93,5 +93,5 @@
 	
 	async_sess_t *hcd_sess =
-	    devman_device_connect(EXCHANGE_SERIALIZE, handle, 0);
+	    devman_device_connect(handle, 0);
 	if (!hcd_sess)
 		return ENOMEM;
@@ -101,5 +101,9 @@
 	
 	async_exch_t *exch = async_exchange_begin(hcd_sess);
-	rc = async_connect_to_me(exch, 0, 0, 0, callback_connection, NULL);
+	
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_USBVIRT_CB, 0, 0,
+	    callback_connection, NULL, &port);
+	
 	async_exchange_end(exch);
 	
Index: uspace/srv/audio/hound/audio_sink.c
===================================================================
--- uspace/srv/audio/hound/audio_sink.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/audio/hound/audio_sink.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -103,5 +103,5 @@
 	if (!pcm_format_is_any(&sink->format)) {
 		log_debug("Sink %s already has a format", sink->name);
-		return EEXISTS;
+		return EEXIST;
 	}
 	const pcm_format_t old_format = sink->format;
Index: uspace/srv/audio/hound/hound.c
===================================================================
--- uspace/srv/audio/hound/hound.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/audio/hound/hound.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -267,5 +267,5 @@
 		if (dev->id == id) {
 			log_debug("Device with id %zu is already present", id);
-			return EEXISTS;
+			return EEXIST;
 		}
 	}
@@ -274,5 +274,5 @@
 	if (dev) {
 		log_debug("Device with name %s is already present", name);
-		return EEXISTS;
+		return EEXIST;
 	}
 
@@ -341,5 +341,5 @@
 		log_debug("Source by that name already exists");
 		fibril_mutex_unlock(&hound->list_guard);
-		return EEXISTS;
+		return EEXIST;
 	}
 	list_append(&source->link, &hound->sources);
@@ -365,5 +365,5 @@
 		log_debug("Sink by that name already exists");
 		fibril_mutex_unlock(&hound->list_guard);
-		return EEXISTS;
+		return EEXIST;
 	}
 	list_append(&sink->link, &hound->sinks);
@@ -420,5 +420,5 @@
 
 	fibril_mutex_lock(&hound->list_guard);
-	const size_t count = list_count(&hound->sources);
+	const unsigned long count = list_count(&hound->sources);
 	if (count == 0) {
 		*list = NULL;
@@ -429,5 +429,5 @@
 	const char **names = calloc(count, sizeof(char *));
 	int ret = names ? EOK : ENOMEM;
-	for (size_t i = 0; i < count && ret == EOK; ++i) {
+	for (unsigned long i = 0; i < count && ret == EOK; ++i) {
 		link_t *slink = list_nth(&hound->sources, i);
 		audio_source_t *source = audio_source_list_instance(slink);
